/* Archive Handler v1.0 - Sean Camanyag                              */
/*   Usage: ARCH.CMD [archive name, full path required]              */
/*===================================================================*/
/* History: v1.0 - Initial release, based on NEWZIPS.CMD [SC]        */
/*-------------------------------------------------------------------*/
/*                                                                   */
/* This is my first real REXX program. I wrote it because I wanted a */
/* way to handle .ZIP and .LZH archives using a WPS Folder.          */
/*                                                                   */
/* I'm pretty much clueless when it comes to programming; most of    */
/* this was done from looking at Felix Sawicki's NEWZIPS.CMD on      */
/* OS/2 Shareware BBS. (NEWZIPS.ZIP)  NEWZIPS seemed intended for    */
/* Sysops who examine all uploads personally.  At the time I was     */
/* calling various BBS's and checking FTP sites for some utility     */
/* that let the user handle .ZIPs via the WPS.                       */
/*                                                                   */
/* I came across a utility that did that, however it was hard-coded  */
/* to use the PKWare OS/2 ZIP programs, which did not support PKZip  */
/* 2.0 format archives. Also, I didn't like its interface.           */
/*                                                                   */
/* So, after about 2 hours of work, constantly looking at the online */
/* REXX documentation and NEWZIPS.CMD, I got this to work            */
/*                                                                   */
/* This program is public domain; feel free to modify it in any way  */
/* you want.  All I ask is that you mention that your modification   */
/* acknowledges me and F. Sawicki, if you upload it somewhere.       */
/* Please let me know of any fixes you make, and where I can         */
/* download it.  My internet email addresses are:                    */
/*                                  scamany@eis.calstate.edu         */
/*                                     bgc1@delphi.com               */ 
/*                                                                   */
/* The documentation from NEWZIPS.CMD says that Felix Sawicki can be */
/* contacted on the local msg area of OS/2 Shareware BBS.            */
/*                                                                   */
/* Disclaimer: (who doesnt use em, these days)                       */
/*             I take no responsibility at all for any damage this   */
/*             rexx program may do. It's provided as-is, no          */
/*             guarantees, etc etc, even if I'm aware of such        */
/*             dangers, etc etc etc etc... You get the idea.         */

'@ECHO OFF'

/* Handle Arguments */
arg arcname

/* Get Archive Type */
type = right(arcname,3)

/* Set work directory - **CHANGE THIS TO YOUR NEEDS** */
workdir = 'E:\Comm\Test\'  

/* Filter out the 8.3 filename...                                      */
/*    Note: Need to find a way to make this work for HPFS filenames -- */
/*    assumes that archive is 8.3 length, up to 1.3. Feel free to fix  */
/*    this part!                                                       */
h = right(arcname,13)
if left(h,1) = '\' then name = right(h,12)
g = right(arcname,12)
if left(g,1) = '\' then name = right(g,11)
f = right(arcname,11)
if left(f,1) = '\' then name = right(f,10)
e = right(arcname,10)
if left(e,1) = '\' then name = right(e,9)
d = right(arcname,9)
if left(d,1) = '\' then name = right(d,8)
c = right(arcname,8)
if left(c,1) = '\' then name = right(c,7)
b = right(arcname,7)
if left(b,1) = '\' then name = right(b,6)
a = right(arcname,6)
if left(a,1) = '\' then name = right(a,5)

/* Check archive type and call appropriate unarchiver  */ 
/* You should be able to add just about any archiving  */
/* program; just use the part below and modify it for  */
/* the appropriate program                             */
select
  when type = 'ZIP'
     then do
     newdirect = workdir||name
     'E:'
     'cd \Comm\Test'
     'md 'name
     'cd 'name
     'unzip -o 'arcname
     if rc = 0 then
        do
        Call SysSetObjectData newdirect, 'OPEN=DEFAULT'
        end
     end
  when type = 'LZH'
     then do     
     newdirect = workdir||name
     'E:'
     'cd \Comm\Test'
     'md 'name
     'cd 'name
     'unzip -o 'arcname
     if rc = 0 then
        do
        Call SysSetObjectData newdirect, 'OPEN=DEFAULT'
        end
     end
  otherwise
  
end
Call SysSetObjectData LEFT(ARCNAME,LENGTH(arcname)-1) , 'OPEN=DEFAULT'    
'cd ..'

/* End of ARCH.CMD */
